Attribute VB_Name = "Module1"
Option Explicit

Type Vector
    x1 As Single
    x2 As Single
    x3 As Single
End Type

Function Colinear(a As Vector, b As Vector) As Boolean
    If VectorIsNull(b) = True Xor VectorIsNull(a) = True Then
        Colinear = False
        Exit Function
    End If
    Dim c1 As Single
    Dim c2 As Single
    Dim c3 As Single
    If a.x1 = 0 And b.x1 = 0 Then c1 = 0
    If a.x2 = 0 And b.x2 = 0 Then c2 = 0
    If a.x3 = 0 And b.x3 = 0 Then c3 = 0
    
    If a.x1 <> 0 Then c1 = b.x1 / a.x1
    If a.x2 <> 0 Then c2 = b.x2 / a.x2
    If a.x3 <> 0 Then c3 = b.x3 / a.x3
    
    If a.x1 = 0 And b.x1 = 0 Then c1 = c2
    If a.x2 = 0 And b.x2 = 0 Then c2 = c3
    If a.x3 = 0 And b.x3 = 0 Then c3 = c1
    
    If c1 = c2 And c2 = c3 And c2 <> 0 Then Colinear = True
End Function

Function Coplanar(a As Vector, b As Vector, c As Vector) As Boolean
    Coplanar = False
    Dim lambda As Single
    Dim my As Single
    If (a.x2 * b.x1 - a.x1 * b.x2) = 0 Then
        lambda = 0
        my = 0
    Else
        lambda = (b.x1 * c.x2 - b.x2 * c.x1) / (a.x2 * b.x1 - a.x1 * b.x2)
        my = (a.x2 * c.x1 - a.x1 * c.x2) / (a.x2 * b.x1 - a.x1 * b.x2)
    End If
    If c.x3 = lambda * a.x3 + my * b.x3 Then Coplanar = True
End Function


Function VectorIsNull(a As Vector) As Boolean
    If a.x1 = 0 And a.x2 = 0 And a.x3 = 0 Then VectorIsNull = True Else VectorIsNull = False
End Function

Function VectorIsEqual(a As Vector, b As Vector) As Boolean
    If a.x1 = b.x1 And b.x2 = b.x2 And a.x3 = b.x3 Then VectorIsEqual = True
End Function

Function VectorSubtract(a As Vector, b As Vector) As Vector
    VectorSubtract.x1 = a.x1 - b.x1
    VectorSubtract.x2 = a.x2 - b.x2
    VectorSubtract.x3 = a.x3 - b.x3
End Function
